' =============================================================================
'
' WinPump
' Utility to switch between static IP and DHCP for a given network connection
'
' albasoft 2009 
'
' You need Administrator rights to run this script. 
' To run it from a user account with password prompt use this command:
' runas /user:<username> "wscript <path>\WinPump.vbs"  
' 
' =================================================================== 

' Connection settings (edit for own purpose)
' ==========================================
  strConnectionID  = "LAN Connection"
  strIPAddress     = Array("0.0.0.0")
  strSubnetMask    = Array("0.0.0.0")
  strGateway       = Array("0.0.0.0")
  strGatewayMetric = Array(1)
  strDNSServers    = Array("0.0.0.0", "0.0.0.0")
  strSuffix        = Array("domain1.com", "domain2.com")


' Initialize
' ==========
  strComputer = "."
  Set objWMIService = GetObject("winmgmts:" & _
      "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")


' Find settings for the desired network connection
' ================================================
  Set colNetAdapters = objWMIService.ExecQuery _
      ("SELECT * FROM Win32_NetworkAdapter WHERE NetConnectionID = '" & strConnectionID & "'")
  For Each objNetAdapter In colNetAdapters
      AdapterIndex = objNetAdapter.Index
  Next
  Set colNetConfigs = objWMIService.ExecQuery _
      ("SELECT * FROM Win32_NetworkAdapterConfiguration Where Index = '" & AdapterIndex & "'")


' Do the changes
' ==============
  For Each objNetConfig in colNetConfigs

      If objNetConfig.DHCPEnabled Then
      	 objNetConfig.DHCPEnabled = FALSE
	 objNetConfig.DomainDNSRegistrationEnabled = TRUE

	 errEnable   = objNetConfig.EnableStatic(strIPAddress, strSubnetMask) 
         errGateways = objNetConfig.SetGateways(strGateway, strGatewaymetric)
         errDNS      = objNetConfig.SetDNSServerSearchOrder(strDNSServers)

	 Set objNetworkSettings = objWMIService.Get("Win32_NetworkAdapterConfiguration")
	 errSuffix = objNetworkSettings.SetDNSSuffixSearchOrder(strSuffix)
	 
         If errEnable=0 and errGateways=0 and errDNS=0 and errSuffix=0 Then
            WScript.Echo "Static IP set."
         Else
            WScript.Echo "Failed to set static IP!"
         End If 

      Else
	
	 strDNSServers = Array()
         objNetConfig.FullDNSRegistrationEnabled = FALSE

         errDNS      = objNetConfig.SetDNSServerSearchOrder(strDNSServers)
 	 errEnable   = objNetConfig.EnableDHCP()

         If errEnable=0 and errDNS=0 Then
            WScript.Echo "DHCP set."
         Else
            WScript.Echo "Failed to set DHCP!"
         End If 

      End If		
  Next
